//  DLL for CBT_HOOK & MOUSE_HOOK

//  ms-help://MS.PSDKSVR2003R2.1033/fileio/fs/creating_named_shared_memory.htm
//  ms-help://MS.PSDKSVR2003R2.1033/winui/winui/windowsuserinterface/windowing/hooks/usinghooks.htm

//  Gen's LowTech : bZ[WtbNg
//  http://www2.biglobe.ne.jp/~sakai/usehook.htm
//  http://www2.biglobe.ne.jp/~sakai/bin/list2.txt

//  Date: Fri, 06 Aug 2004 03:07:35 +0900
//  Subject: [Delphi:82882] HOOK̎gɂ()

//  Date: Fri, 06 Aug 2004 23:22:40 +0900
//  Subject: [Delphi:82897] Re: HOOK̎gɂ()

//  Date: Sat, 07 Aug 2004 16:52:13 +0900
//  Subject: [Delphi:82899] Re: HOOK̎gɂ()

//  Date: Sat, 07 Aug 2004 18:49:34 +0900
//  Subject: [Delphi:82902] Re: HOOK̎gɂ()

//  Date: Wed, 11 Aug 1999 13:05:36 +0900
//  Subject: [Delphi:41483] RE:  OAvP[Vł̌ʂĂяoŎgɂ́H

//  Date: Fri, 01 Dec 2000 19:09:11 +0900
//  Subject: [Delphi:53251] Re: fXNgbṽTuNXiCj

//   http://www.geocities.jp/fjtkt/problems/2003_0005.html
//  BlueLeaf1336-PROBLEMS-2003_0005  ClickThereItIs! - Hook with(out) DLL

//  2007.01.31  
//  2007.02.01  Rgt

//  2007.02.02  MouseHook  fXNgbv_uNbNopɏC
//  2007.02.02  FillChar ŋLNAĂ̖̂肾̂ō폜
//  2007.02.03  CBTHook ŃEBhE̍쐬ʒm

unit DllMain;

interface

uses
    Windows, Messages, SysUtils;

//-----------------------------------------------------------------------------
//  export

//  tbNCXg[
function HookInstall(Wnd: HWND): Boolean; export; stdcall;

//  tbNACXg[
procedure HookUnInstall(); export; stdcall;

implementation

//-----------------------------------------------------------------------------
//  }bvht@C̖O
const
    MAPPEDFILE_NAME = '{D0E04090-0747-46C7-AE5F-C21932619378}';

//-----------------------------------------------------------------------------
//  L̓eɂ\
type
    PShareHookInfo = ^TShareHookInfo;
    TShareHookInfo = packed record
        HostWindow : HWND;     //  ʒmEBhE
        HCbtHook   : HHOOK;    //  CBTtbÑnh
        HMouseHook : HHOOK;    //  MOUSEtbÑnh
    end;

//-----------------------------------------------------------------------------
//  }bvt@C̃nh([Jŕێ)
var
    UMapHandle: THandle = 0;

//-----------------------------------------------------------------------------
//  CBTProc
function CBTProc(nCode: Integer; wParam: WPARAM; lParam: LPARAM): LRESULT; stdcall;
var
    LShare: PShareHookInfo;
begin
    //  r[ǂݏo
    LShare := PShareHookInfo(MapViewOfFile(UMapHandle, FILE_MAP_WRITE, 0, 0, 0));

    //  ʒm
    if not (nCode < 0) then
    begin
        if (nCode = HCBT_CREATEWND) then
        begin
            PostMessage(
                LShare^.HostWindow,     //  CXg[ɕێʒm
                nCode + WM_APP * 1,     //  tbNê܂ܒʒm
                wParam,                 //  gȂ
                lParam);                //  gȂ
        end;
    end;

    //  ΂Ɏɂ܂킷(MapViewOfFilesĂǂ񂾂낤)
    Result := CallNextHookEx(LShare^.HCbtHook, nCode, wParam, lParam);

    //  r[
    UnmapViewOfFile(LShare);
end;

//-----------------------------------------------------------------------------
//  MouseProc
function MouseProc(nCode: Integer; wParam: WPARAM; lParam: LPARAM): LRESULT; stdcall;
var
    LShare: PShareHookInfo;
    LMouseHookStruct: PMouseHookStruct;
begin
    //  r[ǂݏo
    LShare := PShareHookInfo(MapViewOfFile(UMapHandle, FILE_MAP_WRITE, 0, 0, 0));

    //  ʒm
    if not (nCode < 0) then
    begin

        if (nCode = HC_ACTION) then
        begin
            //  tbNo
            LMouseHookStruct := PMouseHookStruct(lParam);

            //  ʒm
            PostMessage(
                LShare^.HostWindow,         //  CXg[ɕێʒm
                WM_APP + 1,                 //  }EXtbNp̃[U[bZ[W
                wParam,                     //  bZ[W̎
                LMouseHookStruct^.hwnd);    //  ΏۃEBhẼnh
        end;
    end;

    //  ΂Ɏɂ܂킷(MapViewOfFilesĂǂ񂾂낤)
    Result := CallNextHookEx(LShare^.HCbtHook, nCode, wParam, lParam);

    //  r[
    UnmapViewOfFile(LShare);
end;

//-----------------------------------------------------------------------------
//  tbNCXg[
function HookInstall(Wnd: HWND): Boolean;
var
    LShare: PShareHookInfo;
begin
    //  IɃACXg[
    HookUnInstall();

    //  r[ǂݏo
    LShare := PShareHookInfo(MapViewOfFile(UMapHandle, FILE_MAP_WRITE, 0, 0, 0));

    //  ʒmێătbNCXg[
    LShare^.HostWindow := Wnd;
    LShare^.HCbtHook := SetWindowsHookEx(WH_CBT, CBTProc, HInstance, 0);
    LShare^.HMouseHook := SetWindowsHookEx(Wh_MOUSE, MouseProc, HInstance, 0);
    Result := (LShare^.HCbtHook > 0) and (LShare^.HMouseHook > 0);

    //  r[
    UnmapViewOfFile(LShare);
end;

//-----------------------------------------------------------------------------
//  tbNACXg[
procedure HookUnInstall();
var
    LShare: PShareHookInfo;
begin
    //  r[ǂݏo
    LShare := PShareHookInfo(MapViewOfFile(UMapHandle, FILE_MAP_WRITE, 0, 0, 0));

    //  tbNACXg[
    if (LShare^.HCbtHook > 0) then
    begin
        UnhookWindowsHookEx(LShare^.HCbtHook);
        LShare^.HCbtHook := 0;
    end;
    if (LShare^.HMouseHook > 0) then
    begin
        UnhookWindowsHookEx(LShare^.HMouseHook);
        LShare^.HMouseHook := 0;
    end;

    //  r[
    UnmapViewOfFile(LShare);
end;

//-----------------------------------------------------------------------------
initialization
begin
    //  }bvht@C쐬
    UMapHandle := CreateFileMapping($FFFFFFFF, nil, PAGE_READWRITE, 0,
                                SizeOf(TShareHookInfo), MAPPEDFILE_NAME);
end;

//-----------------------------------------------------------------------------
finalization
begin
    //  }bvht@Cj(r[͎gp̂тɉĂ)
    CloseHandle(UMapHandle);
end;

end.

